/* ***************** SIMULATED EXAMPLES  *********************************
  EXAMPLE1 : The model considered here is:
             Y = X + 2exp(-16X^2) + varepsilon   with X Uniform(-2,2) or N(0, 1)
                                                 varepsilon N(0,0.4^2)
  EXAMPLE 2: The model considered here is:
             Y = sin(2X) + 2exp(-16X^2) + varepsilon   with X Uniform(-2,2)
                                                       varepsilon N(0,0.3^2)
  EXAMPLE 3:  The model considered here is:
              Y = 0.3 exp(-4(X+1)^2) + 0.7 exp(-16(X-1)^2) + varepsilon
                                                       with X Uniform(-2,2)
                                                       varepsilon N(0,0.1^2)
  EXAMPLE 4:  The model considered here is
              Y = 0.4 x + 1 + varepsilon               with X  N(0, 1)
                                                       varepsilon N(0, 0.15^2)

  OUTPUT:    mhat[ii][0], mhat[ii][1], mhat[ii][2] contain estimated
             curve, bias and variance, respectively
 ************************************************************************
 This program is a modification of the previous program
 "varband.c", the task now is to estimating the regression function by using
 the constant bandwidth.
 ***********************************************************************  */

#include <stdio.h>
#include <math.h>
#define TWOSTAGE 1                           /* 1 means yes, otherwise no */
#define AORDER 2
#define NU     0
#define ADJUST (NU == 0? (TWOSTAGE == 1 ? .7776:.8941):(TWOSTAGE == 0 ? .7639:.7643) )
#define NORMIAL         1.96               /* confidence level */
main()
{
   double *data, *x, *y,*xgrid, **mhat, *coverage, *MISE,*MISEswap, *mtrue;
   double hopt,xgridmin,xgridmax,  tmp, tmp1, sigma;
   int n, ngrid, nsim, Nsim, i, j, order, idum, Idum[3];
   int kfixed, randes, normaldes, iexample, aorder ;
   FILE *reg, *in;
   double *vector(), **matrix(),ran1(), gasdev();
   void sort(), constband(), free_matrix(), free_vector(), exit();
   char filename[15], filename0[15];

          /* INITIALIZATION */

                          /*   randes = 1;   random design or conditonal design
                               normaldes = 1; Normal or Uniform design
                               order:   The order of local polynomial
                                        approximation
                          */
  if(NU == 0) printf("Curve Estimation ADJUST = %10.6f\n", ADJUST);
  else printf("Derivative Estimation ADJUST = %10.6f\n", ADJUST);
  if( TWOSTAGE == 1) printf("TWO-STAGE:   ADJUST = %10.6f\n", ADJUST);
  else   printf("ONE-STAGE:   ADJUST = %10.6f\n", ADJUST);
   randes = 1;
   order = 1+NU;
   normaldes=0;
   ngrid = 101;
   printf("Which Example (0 -- 4) ?\n Example 0 is real data example:      ");
   scanf("%d", &iexample);
   if(iexample == 0)
   { printf("Enter sample size n, ngrid, xgridmin, xgridmax   \n");
     scanf("%d %d %lf %lf",&n, &ngrid, &xgridmin, &xgridmax);
     printf("Enter input filename:  ");
     scanf("%s", filename0);
     printf("Enter OUTPUT filename: ");
     scanf("%s", filename);
     Nsim = 1;         /*dummy variable*/
   }
  else
   {
    printf("Enter n, Nsim:     \n");
    scanf("%d", &n);
    scanf("%d", &Nsim);
    if(iexample == 4) normaldes = 1;
    if(TWOSTAGE ==  1)
       sprintf(filename, ".reg%d.%d", iexample, n);
    else 
        sprintf(filename, ".regone%d.%d", iexample, n);
    reg       = fopen(filename, "w");
   }



  /* MEMORY ALLOCATION */
 xgrid=vector(0,ngrid);
 x=vector(0,n);
 y=vector(0,n);
 mhat=matrix(0,ngrid,0,3);
 coverage = vector(0,ngrid);            /* % of coverage probability */
 MISE = vector(0,Nsim);
 MISEswap = vector(0, Nsim);
 mtrue = vector(0, ngrid);
            /*  INITIALIZATION */
 for(i=0; i < ngrid; i++)           /* COMPUTING GRID POINTS */
     {
       xgrid[i] = -1.8 + (double) i * 3.6 /(double) (ngrid -1);
       coverage[i] = 0.0;
     }
    switch(iexample)
      {
      case 0: in = fopen(filename0, "r"); /*real data*/
            reg = fopen(filename,"w");
            for(i=0; i < n; i++)
                 fscanf(in, "%lf %lf", x+i, y+i);
            for(i=0; i < ngrid; i++)  xgrid[i] = xgridmin+i*
                                 (xgridmax-xgridmin)/(ngrid -1.0);
            constband(x, y, n, order, xgrid, ngrid, mhat, &hopt);
      fprintf(reg, "Real data: ngrid=%d,xgridmin=%10.4f,xgridmax=%10.4f,NU=%d",
                       ngrid, xgridmin, xgridmax, NU);
            fprintf(reg, "\n estimated bandwidth is %10.6f", hopt);
            fprintf(reg, "\nGRID POINTS   ESTIMATD VALUES   Bias Variance");
            fprintf(reg, "\n\n\n\n\n");
            for(j=0;j < ngrid; j++) fprintf(reg,"%12.4f %12.4f %12.4f %12.4f\n",
                 xgrid[j], mhat[j][0], mhat[j][1], mhat[j][2]);
            exit(1);

       case 1: sigma = 0.4;
               for(i=0; i < ngrid; i++)
                    { tmp = xgrid[i];
                      mtrue[i]= tmp+2.0*exp(-16.0*tmp*tmp);
                    }
                break;

       case 2: sigma = 0.3;
               for(i=0; i < ngrid; i++)
                    { tmp = xgrid[i];
                      mtrue[i]  = sin(2.0*tmp) +  2.0*exp(-16.0*tmp*tmp);
                    }
                break;

       case 3: sigma = 0.1;
               for(i=0; i < ngrid; i++)
                    { tmp = xgrid[i];
                      mtrue[i] = 0.3 * exp(-4.0*(tmp + 1.0)*(tmp+1.0))
                             + 0.7 *exp(-16.0 * (tmp-1.0)* (tmp-1.0));
                    }
                break;

       case 4: sigma = 0.15;
               for(i=0; i < ngrid; i++)
                    { tmp = xgrid[i];
                      mtrue[i]  =  0.4 * tmp +1.0;
                    }
                break;
	       
     default:  printf("Out of Example list:\n");
               exit(1);
     }

fprintf(reg, "EXAMPLE %d with randes = %d, normaldes = %d\n", iexample,
	 randes, normaldes);
fprintf(reg, "sample size n = %d, number of simulations = %d, sigma =%10.6f \n",
         n, Nsim, sigma);
fprintf(reg, "THE ESTIMATED BANDWIDTH AND THE ESTIMATED CRUVES ARE: \n");
fprintf(reg, "(opt bandwidth first, then curve estimates and their \n");
fprintf(reg, "     associated BIAS and VARIANCE at 90%, 50% and 10%)\n \n\n");



/* *************************************************************
                    SIMULATION STARTS
   ************************************************************  */

  tmp = 4.0 / (double) n;        /* grid size */
  if(randes==0)                 /* fixed point uniform design */
         for(i=1, x[0] = -2.0 + tmp/2.0; i < n; i++) x[i] = x[i-1]+tmp;


  for(nsim=0; nsim < Nsim; nsim++)
    {
     idum = -10*nsim*nsim-2+nsim;
                      /* GENERATE DATA */
     if(randes == 1)                 /*random design */
       {  if(normaldes == 1)         /*normal design */
              for(i=0; i < n; i++) x[i] =  gasdev(&idum);
          else                      /*uniform design */
              for(i=0; i < n; i++) x[i] =   4.0* ran1(&idum) - 2.0;
          sort(x,n);   /* sorted x-design */
       }

    switch(iexample)
      {
       case 1: for(i=0; i < n; i++)
                    { tmp = x[i];
                      y[i]= tmp+2.0*exp(-16.0*tmp*tmp) + sigma*gasdev(&idum);
                    }
                break;

       case 2: for(i=0; i < n; i++)
                    { tmp = x[i];
                      tmp  = sin(2.0*tmp) +  2.0*exp(-16.0*tmp*tmp);
                      y[i]   = tmp + sigma*gasdev(&idum);
                    }
                break;

       case 3: for(i=0; i < n; i++)
                    { tmp = x[i];
                      tmp = 0.3 * exp(-4.0*(tmp + 1.0)*(tmp+1.0))
                             + 0.7 *exp(-16.0 * (tmp-1.0)* (tmp-1.0));
                      y[i]  =  tmp  + sigma*gasdev(&idum);
                    }
                break;

       case 4: for(i=0; i < n; i++)
                    { tmp = x[i];
                      y[i]  =  0.4 * tmp +1.0 + sigma*gasdev(&idum);
                    }
                break;
       }


     /*COMPUTE THE ESTIMATED SIGMA BY Seifert, Gasser and Wolf "new"
       difference based estimator m=3. The estimated sigma is in y[n]
      sigma = 0.0;
      for(i=0; i < n-3; i++)
         {
          tmp = 0.535*y[i] -0.802*y[i+1] + 0.267*y[i+3];
          tmp *= tmp;
          sigma += tmp;
         }
       y[n]   = sqrt(sigma /(double) n);    
    */

   
    constband(x, y, n, order, xgrid, ngrid, mhat, &hopt);
    fprintf(reg, "%10.6f\n", hopt); 
    tmp = 0.0;
    for(j=0; j < ngrid; j++) tmp += fabs(mhat[j][0] - mtrue[j]);  
    MISE[nsim] = tmp;
    for(j=0; j < ngrid; j++)
      { tmp = mhat[j][0] - mhat[j][1];
	tmp1 = NORMIAL*mhat[j][2];
	if(tmp-tmp1 < mtrue[j] && mtrue[j] < tmp + tmp1)
	         coverage[j]+=1.0;
      }
      
  printf("Example %d,  n = %d, nsim =%d, MISE=%10.6f, hopt =%10.6f\n",
	iexample, n, nsim, tmp/ngrid, hopt);
  }     /*finish the loop with nsim */

  fprintf(reg, "Coverage Probability\n");
  for(j=0; j < ngrid; j++) fprintf(reg, "%7.4f \n", coverage[j]/Nsim);
  fprintf(reg, "Estimated curves     biases    variances %\n\n\n" );

  for(i=0; i < Nsim; i++) MISEswap[i] = MISE[i];
  sort(MISE, Nsim);
  i=0.1*Nsim;  tmp = MISE[i];  /*10th percentile's random seed */
  for(i=0; i < Nsim; i++) 
	if(fabs(MISEswap[i] - tmp) < 0.00001) Idum[0] = -10*i*i-2+i;
  i =0.5*Nsim;  tmp = MISE[i];  /*50th percentile's random seed */
  for(i=0; i < Nsim; i++)
        if(fabs(MISEswap[i] - tmp) < 0.00001) Idum[1] = -10*i*i-2+i;
  i=0.9*Nsim;  tmp = MISE[i];  /*90th percentile's random seed */
  for(i=0; i < Nsim; i++)
        if(fabs(MISEswap[i] - tmp) < 0.00001) Idum[2] = -10*i*i-2+i;
  printf("%d, %d, %d\n", Idum[0], Idum[1], Idum[2]);
      /* NOW RESIMULATE USING THE OLD SEED */
 for(nsim=0; nsim < 3; nsim++)
    {
     idum = Idum[nsim];
                      /* GENERATE DATA */
     if(randes == 1)                 /*random design */
       {  if(normaldes == 1)         /*normal design */
              for(i=0; i < n; i++) x[i] =  gasdev(&idum);
          else                      /*uniform design */
              for(i=0; i < n; i++) x[i] =   4.0* ran1(&idum) - 2.0;
          sort(x,n);   /* sorted x-design */
       }

    switch(iexample)
      {
       case 1: for(i=0; i < n; i++)
                    { tmp = x[i];
                      y[i]= tmp+2.0*exp(-16.0*tmp*tmp) + sigma*gasdev(&idum);
                    }
                break;

       case 2: for(i=0; i < n; i++)
                    { tmp = x[i];
                      tmp  = sin(2.0*tmp) +  2.0*exp(-16.0*tmp*tmp);
                      y[i]   = tmp + sigma*gasdev(&idum);
                    }
                break;

       case 3: for(i=0; i < n; i++)
                    { tmp = x[i];
                      tmp = 0.3 * exp(-4.0*(tmp + 1.0)*(tmp+1.0))
                             + 0.7 *exp(-16.0 * (tmp-1.0)* (tmp-1.0));
                      y[i]  =  tmp  + sigma*gasdev(&idum);
                    }
                break;

       case 4: for(i=0; i < n; i++)
                    { tmp = x[i];
                      y[i]  =  0.4 * tmp +1.0 + sigma*gasdev(&idum);
                    }
                break;
       }


    constband(x, y, n, order, xgrid, ngrid, mhat, &hopt);

    for(j=0; j < ngrid; j++) fprintf(reg, "%12.4f %12.4f %12.4f \n", 
	     mhat[j][0], mhat[j][1], mhat[j][2]);
    fprintf(reg, "\n \n \n");

    tmp = 0.0;
    for(j=0; j < ngrid; j++) tmp += fabs(mhat[j][0] - mtrue[j]);
    MISE[nsim] = tmp;
    printf("Example %d,  n = %d, MISE=%10.6f, hopt =%10.6f\n",
        iexample, n, tmp/ngrid, hopt);

  }     /*finish the loop with nsim */


}




/* ************************* CONSTBAND.C ******************************
   ******************************************************************
  Main program: Constant.C : select the bandwidth
  via a loop through bandwidth and do the fixed-order polynomial
  approximation.
  Calls for: LLS.C : which is the program doing the locally weighted
                         least squares regression

  Other programs called are:
               GAUSSJ.C : Solves a linear equation using Gauss-Jordan
                          elimination (see e.g. the book "Numerical
                          Recipes in C", by Press,Flannery, Teukolsky and
                          Vetterling, Cambridge University Press (1988))
               SORT.C : sorting a vector
               RAN1.C : random number generator for uniform (0,1)
                        distributed random variables
               GASDEV.C : random number generator, generates standard
                          normal distributed random variables; relies
                          on the Box-Muller method and uses the
                          random number generator for uniform random
                          variables (i.e calls RAN1.C)
               Utility Programs:
                  IVECTOR.C : memory allocation for integer-valued vector
                  VECTOR.C : memory allocation for vector
                  MATRIX.C : memory allocation for matrix

                  FREE_MATRIX.C : frees the memory allocated by MATRIC
                  FREE_IVECTOR.C : frees the memory allocated by IVECTOR
                  FREE_VECTOR.C : frees the memory allocated by VECTOR

                  NERROR.C : prints an error message.
**************************************************************************
************************************************************************** */


void constband(x, y, n, order, xgrid, ngrid, mhat, hopt)
double *x, *y, *xgrid, **mhat, *hopt;
int n,order, ngrid;
#define LARGE 1.0e17
#define SPAN  1.1                             /*maximum number of iteration*/
#define IUP   3                               /*checking conv of iteration*/ 
#define MIN(i,j) ( (i) > (j) ? (j):(i) )
#define MAX(i,j) ( (i) > (j) ? (i):(j) )
#define ABS(i)   (  (i) >= 0  ? (i):-(i))

 /*      OPTIMAL BANDWIDTH AND REGRESSION ESTIMATION
         Input : x :n-column vector containing the covariates;
                 y : n-column vector with the responses;
                 order : 0 = local constant approximation
                         1 = local linear approximation,
                         2 = local quadratic approximation,
                         3 = local cubic approximation,
                         etc. .....,
                 xgrid : ngrid-column vector with the grid points in
                         which the final regression estimator mhat is
                         calculated;
         Output : mhat  estimated regression curve, bias and var at grid points;
		  hopt:  the optimal bandwidth.
  */

{
  int i, ii, iup, ismooth, j, nrow, nm, a;
  double **beta, **betatmp, *SE, *RSC;
  double  h, hmin, hmax,hopt1,MASE, MSEnew, MSEold, xx, xmin, xmax, tmp, sigma;
  double hopt2, MASEopt, *vector(), **matrix();
  void free_vector(), free_matrix();
  void sort(), lls();

                                   /*MEMORY ALLOCATION */
  nm = order+8;
  beta=matrix(0,nm,0,1);  
  betatmp = matrix(0,nm, 0, ngrid);
  SE=vector(0,nm);        RSC = vector(0,nm);

  xmin=x[0]; xmax=x[0];
  for(i=0; i < n; i++)
       {if(x[i] < xmin) xmin = x[i];
	if(x[i] > xmax) xmax = x[i];
        }
  hmin =  (xmax - xmin)*(order+2.0)/n;   /* exp(-0.8*log((double) n)); */
  hmax = (xmax - xmin)/2.0;


  
  /*   a = AORDER;    approximation order*/

 if(TWOSTAGE == 1)                               /* TWO-STAGE PLUGIN */
   { a = AORDER; h = (2.0 +NU)* hmin;}
 else
   { a = 0;  h = hmin;}

  hopt1 = h; iup = 0; 
  MSEnew = LARGE; MASEopt = LARGE;
                    /*SEARCH FOR OPTIMAL BANDWIDTH FOR LOCAL order+a FIT */
  while(iup < IUP && h < hmax)
   { MASE = 0.0;
     for(ii = 0; ii < ngrid; ii++)   /* for each grid point */
       {xx = xgrid[ii];
				 /* nrow = # of effective data points */
        for(nrow = 0, i=0; i < n; i++) if(fabs(xx - x[i]) < h) nrow++;
        if(nrow > 2*(order+a)) /* NOT Nearly singular case */
            { lls(x,y,n,order+a,xx,h, beta, SE, &sigma, RSC, 1);
	      MASE    += RSC[0];
            }
        else{iup=0; goto lab1;}
       }
      MSEold = MSEnew;
      MSEnew = MASE;
      if(MSEnew > MSEold) iup++; else iup = 0;
      if(MSEnew < MASEopt) {MASEopt = MSEnew; hopt1 = h;}


lab1: h *= SPAN;
   }      /*end-loop through h*/
   hopt1 *=  ADJUST;   
   hopt2 = hopt1;

if( TWOSTAGE == 1)
{
  h = (1.0 + NU)*hmin;  hopt2 = h;
  iup = 0; MSEnew = LARGE; MASEopt = LARGE;

      /* ************* ESTIMATE CURVATIVE FIRST ********** */
  for(ii =0; ii < ngrid; ii++) 
    {  xx = xgrid[ii];
       lls(x,y,n,order+a,xx,hopt1, beta, SE, &sigma, RSC, 0); /*(order+a)-fit */
       for(i=0; i <= order+a; i++) betatmp[i][ii] = beta[i][0];
     }
           /*END priliminary fit to learn beta_2 so that it can be passed  */

  while(iup < IUP && h < hmax)
   {MASE=0.0; 
    for(ii=0; ii < ngrid; ii++)
     { xx = xgrid[ii];
       for(i=0; i <= order+a; i++) beta[i][1] = betatmp[i][ii];
           /*END priliminary fit to learn beta_2 so that it can be passed 
	     to compute the bias NOW TRY LOCAL order-FIT,
	     nrow = # of effective data points */
       for(nrow = 0, i=0; i < n; i++) if(fabs(xx - x[i]) < h) nrow++;
       if(nrow <= order+a)                   /* Nearly singular case */
          {iup=0; goto lab2;}
       else
           { lls(x,y,n,order,xx,h, beta, SE, &sigma, RSC, a);
	      MASE += beta[NU][1]*beta[NU][1] + SE[NU]*SE[NU];
            }  
      }               /*end loop through ii */

    MSEold = MSEnew;
    MSEnew = MASE;
    if(MSEnew > MSEold) iup++; else iup = 0;
    if(MSEnew < MASEopt) {MASEopt = MSEnew; hopt2 = h;}

lab2: h *= SPAN;
   }                             /*end loop through h */
     /* hopt2 = h * exp(-(IUP+1)*log(SPAN)); */
           /* optimal bandwidth for local order-fit*/
 }                /* end-if with TWOSTAGE == 1 */
                /* NOW COMPUTE COMPUTE THE ESTIMATED CURVE */

 
  for(ii=0; ii < ngrid; ii++)  
   { xx = xgrid[ii];
     lls(x,y,n,order,xx,hopt2, beta, SE, &sigma, RSC, a);
     mhat[ii][0] = beta[NU][0];
     mhat[ii][1] = beta[NU][1];
     mhat[ii][2] = SE[NU];
   }                               /*end the loop through ii */

   hopt[0] = hopt2;
    free_matrix(beta,0,nm, 0, 1); 
    free_matrix(betatmp,0,nm,0,ngrid);
    free_vector(SE,0,nm); 
    free_vector(RSC, 0, nm);
}


/* *************  GAUSSJ.C ************** */
/* #include <math.h>
#include <stdio.h>  */
#define SWAP(a,b) {double temp=(a);(a)=(b);(b)=temp;}
#define TINY 1.0e-12;
void gaussj(a,n,b,m)
     /* Linear equation solution by Gauss-Jordan elimination
        Input: a: n by n input matrix
               b: n by m input matrix containing the m right-hand sides
                  vectors of the equation-system
        In the present version, b is a column vector (m=1). The program
        has to be changed slightly for the general case (m > 1). In this
        case, b should be declared as a matrix and e.g. line 58 should
        look like:
            for (l=1; l<=m; l++) SWAP(b[irow-1][l-1], b[icol-1][l-1])
        Output: a: the input matrix a is replaced be its matrix inverse
                b: the input matrix is replaced by the corresponding set
                   of solution vectors. */

double **a,**b;
int n,m;

{
  int *indxc,*indxr,*ipiv;
  int i,icol,irow,j,k,l,ll, *ivector();
  double big,dum,pivinv;
  void nrerror(), free_ivector();

  indxc=ivector(1,n);
  indxr=ivector(1,n);
  ipiv=ivector(1,n);


  for (j=1; j <= n; j++) ipiv[j]=0;
  for (i=1; i <= n; i++) {
        big=0.0;
        for (j=1; j <= n; j++)
            if (ipiv[j] !=1)
                 for (k=1; k<=n; k++) {
                   if (ipiv[k] == 0) {
                       if (fabs(a[j-1][k-1]) >= big) {
                           big=fabs(a[j-1][k-1]);
                           irow=j;
                           icol=k;
                       }
                   } else if (ipiv[k] > 1) nrerror("GAUSSJ: Singular Matrix-1");
            }
        ++(ipiv[icol]);

        if (irow !=icol) {
            for (l=1; l<=n; l++) SWAP(a[irow-1][l-1], a[icol-1][l-1])
            for (l=1; l<=m; l++) SWAP(b[irow-1][l-1], b[icol-1][l-1])
        }
        indxr[i]=irow;
        indxc[i]=icol;
        if (fabs(a[icol-1][icol-1]) == 0.0) a[icol-1][icol-1] = TINY;
        pivinv=1.0/a[icol-1][icol-1];
        a[icol-1][icol-1]=1.0;
        for(l=1;l<=n;l++) a[icol-1][l-1] *=pivinv;
        for(l=1;l<=m;l++) b[icol-1][l-1] *=pivinv;
        for (ll=1;ll<=n;ll++)
            if (ll !=icol) {
                dum=a[ll-1][icol-1];
                a[ll-1][icol-1]=0.0;
                for (l=1;l<=n;l++) a[ll-1][l-1] -= a[icol-1][l-1]*dum;
                for (l=1;l<=m;l++) b[ll-1][l-1] -= b[icol-1][l-1]*dum;
            }
  }
  for (l=n; l>=1;l--) {
      if (indxr[l] !=indxc[l])
	for(k=1; k<=n; k++)
                      SWAP(a[k-1][indxr[l]-1],a[k-1][indxc[l]-1]);
  }
  free_ivector(ipiv,1,n);
  free_ivector(indxr,1,n);
  free_ivector(indxc,1,n);
}

/*       ********************* SORT.C ***************** */
void sort(ra,n)
int n;
double *ra;
/*index of ra is 0:n-1*/
{
        int l,j,ir,i;
        double rra;

        l=(n >> 1)+1;
        ir=n;
        for (;;) {
                if (l > 1)
                        rra=ra[--l-1];
                else {
                        rra=ra[ir-1];
                        ra[ir-1]=ra[0];
                        if (--ir == 1) {
                                ra[0]=rra;
                                return;
                        }
                }
                i=l;
                j=l << 1;
                while (j <= ir) {
                        if (j < ir && ra[j-1] < ra[j]) ++j;
                        if (rra < ra[j-1]) {
                                ra[i-1]=ra[j-1];
                                j += (i=j);
                        }
                        else j=ir+1;
                }
                ra[i-1]=rra;
        }
}

/* ******************** UNIFORM RANDOM NUMBER GENERATOR: RAN1.c ******* */
#include <stdlib.h>
#define M1 259200
#define IA1 7141
#define IC1 54773
#define RM1 (1.0/M1)
#define M2 134456
#define IA2 8121
#define IC2 28411
#define RM2 (1.0/M2)
#define M3 243000
#define IA3 4561
#define IC3 51349

double ran1(idum)
int *idum;

                    /* returns a uniform random deviate between 0.0 and 1.0.
                       Set idum to any negative value to initialize or
                       reinitialize the sequence  */

{
    static long ix1,ix2,ix3;
    static double r[98];
    double temp;
    static int iff=0;
    int j;
    void nrerror();

    if (*idum < 0 || iff == 0) {
         iff=1;
         ix1=(IC1-(*idum)) % M1;
         ix1=(IA1*ix1+IC1) % M1;
         ix2=ix1 % M2;
         ix1=(IA1*ix1+IC1) % M1;
         ix3=ix1 % M3;
         for (j=1;j<=97;j++) {
               ix1=(IA1*ix1+IC1) % M1;
               ix2=(IA2*ix2+IC2) % M2;
               r[j]=(ix1+ix2*RM2)*RM1;
           }
           *idum=1;
    }
    ix1=(IA1*ix1+IC1) % M1;
    ix2=(IA2*ix2+IC2) % M2;
    ix3=(IA3*ix3+IC3) % M3;
    j=1 + ((97*ix3)/M3);
    if (j > 97 || j < 1) nrerror("RAN1: This cannot happen.");
    temp=r[j];
    r[j]=(ix1+ix2*RM2)*RM1;
    return temp;
}

/* ***************** NORMAL RANDOM GENERATOR: GASDEV.C *********** */
double gasdev(idum)
int *idum;
                   /* returns a normally distributed deviate with mean 0
                      and variance 1, using ran1(idum) as the source of uniform
                      deviates    */

{
    static int iset=0;
    static double gset;
    double fac,r,v1,v2;
    double ran1();

    if (iset == 0)  {
        do {
            v1=2.0*ran1(idum)-1.0;
            v2=2.0*ran1(idum)-1.0;
            r=v1*v1+v2*v2;
        } while (r >= 1.0 || r == 0.0);
        fac= sqrt(-2.0*log(r)/r);
        gset=v1*fac;
        iset=1;
        return v2*fac;
    }  else {
         iset=0;
         return gset;
    }
}

/*                    UTILITY PROGRAMS  */
/* ************************************************************************* */
/*        *************** IVECTOR.C  **********    */
int *ivector(nl, nh)
int nl, nh;
{  int *v;
   v = (int *)malloc((unsigned) (nh-nl+1) * sizeof(int));
   return v-nl;
}

/*        *************** VECTOR.C  **********    */
double *vector(nl, nh)
int nl, nh;
{  double *v;
   v = (double *)malloc((unsigned) (nh-nl+1) * sizeof(double));
   return v-nl;
}


/*        ***************MATRIX.C  **********    */
double **matrix(nrl,nrh,ncl,nch)
int nrl,nrh,ncl,nch;

        /* Allocates a double matrix with range [nrl..nrh][ncl..nch]    */

{
    int i;
    double **m;

    m=(double **) malloc((unsigned) (nrh-nrl+1)*sizeof(double*));
    m -=nrl;

    for(i=nrl;i<=nrh;i++) {
         m[i]=(double *) malloc((unsigned) (nch-ncl+1)*sizeof(double));
         m[i] -= ncl;
    }
    return m;
}

/*        ***************FREE_MATRIX.C  **********    */
void free_matrix(m,nrl,nrh,ncl,nch)
double **m;
int nrl,nrh,ncl,nch;
                     /* Frees a matrix allocated with matrix */

{
    int i;

    for(i=nrh;i>=nrl;i--) free((char*) (m[i]+ncl));
    free((char*) (m+nrl));
}

/*        ***************FREE_IVECTOR.C  **********    */
void free_ivector(v,nl,nh)
int *v,nl,nh;
                       /* Frees an int vector allocated by ivector() */

{
     free((char*) (v+nl));
}

/*        ***************FREE_VECTOR.C  **********    */
void free_vector(v,nl,nh)
double *v;
int nl,nh;
                       /* Frees a double vector allocated by vector() */

{
     free((char*) (v+nl));
}


/*    *********************NRERROR.C ******************** */
void nrerror(error_text)
     /* prints an error message */

char error_text[];
{
   fprintf(stderr,"Numerical recipes run-time error...\n");
   fprintf(stderr,"%s\n",error_text);
   fprintf(stderr,"...now exiting to system...\n");
   exit(1);
}

/* *******************************LLS.C ************************ */
void lls(x,y,n,p,xx,h, beta, SE, sigma, RSC, a)
double *x, *y,xx,h, **beta, *SE,*sigma, *RSC;
int     n,  p, a;
  /*Do locally weighted least-squared by using local polynomial of order p
    Input: x is n-vector of design
	   y is n-vector of the response
	   xx is the point where the estimated value to be returned
	   h  is the bandwidth and the kernel is Epnechnikov;
           n and p explained above
	   beta: (p+a) by 2 matrix.
           beta[.][1] estimated coefficients to be used to estimate
		      bias: (p+a)-vector;
	   a: approximation order in the plub-in procedure and
              > 0, return regression coefficients along with others
	      = 0, return only estimated regression coefficient.

    Output:  beta[.][0]: estimated regression coefficients (0 -- p)
             beta[.][1]: estimated bias according to (2.7) (0 -- p).  
             SE:  p-column vector of estimated SE-values of
                  the estimated regression coefficients for the
                  first response vector.
                  t = beta/SE
             sigma: the estimated standard error of linear model.
             RSC:  Extrended cross-validated values computed as follows. 
  */
{
 int i,j,l,nrow, nmax;
 double tmp, tmp1, *Xdes,*Y, **H, **Ha, *w ;
 double RSS, sum, sumw, trace;
 double **matrix(), *vector(), *s, *S;
 void   free_matrix(), free_vector();
  
      /*MEMORY ALLOCATION*/
  nmax = MAX(p+a, 2*p+2);             /* max moments to be computed */
  Xdes = vector(0,n);                   Y    = vector(0,n); 
  H=matrix(0,p,0,p);                    Ha   = matrix(0,p,0,p);
  w    = vector(0, n);                  s    = vector(0,nmax);
  S    = vector(0, nmax);
 
      /* DETERMINING THE LOCAL DATA POINTS */
  nrow=0;                                 /* Effective number of data points*/
  sumw =0.0;                              /* Total weight */
  for(i=0; i < n; i++)
      {tmp = (xx - x[i])/h; tmp *=tmp;
       if(tmp < 1.0)
          {w[nrow] = 1.0 - tmp;                   /* Epanechnikov kernel */
           sumw += w[nrow];
           Xdes[nrow] = x[i] - xx;
           Y[nrow]    = y[i];
           nrow++;
          }
       }

      /* COMPUTE  s[j] = \sum w[i] (X[i]-x)^j,
                  S[j] = \sum w[i]^2 (X[i]-x)^j, beta[j][0] = X'Wy[j]  */

    for(j=0; j <= nmax; j++) {s[j]=0.0; S[j]=0.0;}
    for(j=0; j <= p; j++)      beta[j][0] =0.0;
    for(i=0; i < nrow; i++)
      { tmp = 1.0;                    /*tmp = Xdes[i]^j */
        for(j=0; j <= nmax; j++)
            {tmp1 = w[i]*tmp;         
             s[j] += tmp1;
             S[j] += w[i]*tmp1;   
	     if(j <= p) beta[j][0] += tmp1*Y[i];
             tmp *= Xdes[i];
            }
       }

   /*computing H= X'WX, Ha = X'W^2X*/
   for(i=0; i <=p; i++)
        for(j=0; j <=p; j++)
        	  {  H[i][j] = s[i+j]; Ha[i][j] = S[i+j]; }


			  /* compute beta[.][1] according to (2.7) */
  if(a > 0)
   {
     for(i=0; i <= p; i++) 
       { tmp = 0.0;
         for(j=p+1; j <= p+a; j++) 
	    if(j+i <= p+a) tmp += beta[j][1] * s[j+i];
         beta[i][1] = tmp; 
       }
    }


  gaussj(H,p+1,beta,2);            /* solve H b = beta;
                                     output: H <- H^{-1}, beta <- H^{-1} beta */

if(a > 0)
 {
  for(RSS=.0, i=0; i < nrow; i++)   /* compute weighted residual sum of squares
                                     RSS = sum_1^n (y_i - \hat{y}_i)^2 w_i
                                     for the 0th column of Y */
   {
     sum=0.0; tmp=1.0;               /* tmp = Xdes[i]^l */
     for(l=0; l <= p; l++)   
	   { sum += tmp * beta[l][0] ; tmp *= Xdes[i];}
     RSS += (Y[i] - sum) * (Y[i] - sum)*w[i];
   }


  trace = 0.0;                   /*trace =  tr((X'WX)^{-1} X'W^2X )*/
  for(i=0; i <= p ; i++)
       {  tmp = 0.0;
          for(j=0; j<i; j++) tmp += H[i][j] * Ha[j][i];
          trace += H[i][i]*Ha[i][i] + 2.0 * tmp;
       }
  trace = sumw - trace;          /*trace = tr(W) -  tr((X'WX)^{-1} X'W^2X )*/


  RSS =  RSS / trace;            /* standardarized residual sum of squares */



  for (l = 0; l <= p; l++)  
   { sum = 0.0;              /*lth element of (X'WX)^{-1}(X'W^2X)(X'WX)^{-1}*/
     for(i=0; i <= p; i++)
        {
	  tmp = 0.0;
          for(j=0; j<i; j++) tmp += Ha[i][j] * H[j][l];
          sum += H[i][l]*(Ha[i][i]*H[i][l]+2.0 * tmp);
        }
     SE[l] = sqrt(RSS *sum);
     RSC[l] = sum;
   }

  RSC[0] = RSS * (1.0 + (p+1)*RSC[0]);

  sigma[0] = sqrt(RSS);
  }  /* end-if */

  free_vector(Xdes, 0,n);               free_vector(Y, 0,n);
  free_matrix(H,0,p,0,p);               free_matrix(Ha,0,p,0,p);
  free_vector(w, 0, n);                 free_vector(s, 0,nmax);
  free_vector(S,  0, nmax);

}
